unit DateTimeEqual;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, AdvPanel,
  Vcl.ComCtrls;

type
  TFDateTimeEqual = class(TForm)
    StatusBar1: TStatusBar;
    AdvPanel1: TAdvPanel;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    procedure FormShow(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    procedure DisplayHint(Sender: TObject);
  public
    { Public declarations }
  end;

var
  FDateTimeEqual: TFDateTimeEqual;

implementation
uses Main,ExifTool;
{$R *.dfm}
const
  CmdDateOriginal='-exif:DateTimeOriginal';
  CmdDateCreate='-exif:CreateDate';
  CmdDateModify='-exif:ModifyDate';
  srcTx: string[23]='-use as source';
  dstTx: string[23]='-and copy here';
var ETcmd:string;
  clLite,clDark:TColor;

procedure TFDateTimeEqual.Button2Click(Sender: TObject);
begin
  ETcmd:='';
  if RadioButton1.Checked then
    ETcmd:='-exif:DateTimeOriginal>exif:ModifyDate'+CRLF+'-exif:DateTimeOriginal>exif:CreateDate';
  if RadioButton2.Checked then
    ETcmd:='-exif:CreateDate>exif:ModifyDate'+CRLF+'-exif:CreateDate>exif:DateTimeOriginal';
  if RadioButton3.Checked then
    ETcmd:='-exif:ModifyDate>exif:DateTimeOriginal'+CRLF+'-exif:ModifyDate>exif:CreateDate';

  ET_OpenExec(ETcmd,FMain.GetSelectedFiles);
  FMain.UpdateLogWin;
  FMain.DeleteTmpFile;
  ModalResult:=mrOK;
end;

procedure TFDateTimeEqual.DisplayHint(Sender: TObject);
begin
  StatusBar1.SimpleText:=GetShortHint(Application.Hint);
end;

procedure TFDateTimeEqual.FormShow(Sender: TObject);
begin
  Left:=FMain.Left+FMain.GUIBorderWidth+FMain.AdvPageFilelist.Left;
  Top:=FMain.Top+FMain.GUIBorderHeight;

  clLite:=FMain.GUIclLite; clDark:=FMain.GUIclDark;
  Color:=clDark;
  with AdvPanel1 do begin
    ParentBackground:=false; Color:=clLite; ColorTo:=clNone;
  end;
  if FMain.MDontBackup.Checked then Label1.Caption:='Backup: OFF'
                               else Label1.Caption:='Backup: ON';
  Application.OnHint:=DisplayHint;

  ETcmd:='-s3'+CRLF+'-f'+CRLF+CmdDateOriginal+CRLF+CmdDateCreate+CRLF+CmdDateModify;
  ET_OpenExec(ETcmd,FMain.ShellList.SelectedFiles[0]);
  LabeledEdit1.Text:=ETout[0]; LabeledEdit2.Text:=ETout[1]; LabeledEdit3.Text:=ETout[2];
  LabeledEdit1.Color:=clLite; LabeledEdit2.Color:=clLite; LabeledEdit3.Color:=clLite;
  RadioButton1.SetFocus;
end;

procedure TFDateTimeEqual.RadioButton1Click(Sender: TObject);
begin
  if Sender=RadioButton1 then begin
    RadioButton1.Caption:=SrcTx;
    RadioButton2.Caption:=DstTx;
    RadioButton3.Caption:=DstTx;
  end;
  if Sender=RadioButton2 then begin
    RadioButton1.Caption:=DstTx;
    RadioButton2.Caption:=SrcTx;
    RadioButton3.Caption:=DstTx;
  end;
  if Sender=RadioButton3 then begin
    RadioButton1.Caption:=DstTx;
    RadioButton2.Caption:=DstTx;
    RadioButton3.Caption:=SrcTx;
  end;
end;

end.
