unit FileDateTime;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, AdvPanel, Vcl.ComCtrls,
  Vcl.StdCtrls;

type
  TFFileDateTime = class(TForm)
    StatusBar1: TStatusBar;
    AdvPanel1: TAdvPanel;
    AdvPanel2: TAdvPanel;
    Button1: TButton;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    RadioGroup3: TRadioGroup;
    RadioGroup4: TRadioGroup;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Edit1: TEdit;
    Button2: TButton;
    AdvPanel3: TAdvPanel;
    RadioButton1: TRadioButton;
    Button3: TButton;
    AdvPanel4: TAdvPanel;
    RadioButton2: TRadioButton;
    Button4: TButton;
    procedure FormShow(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure RadioGroup3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
    procedure DisplayHint(Sender: TObject);
  public
    { Public declarations }
  end;

var
  FFileDateTime: TFFileDateTime;

implementation
uses Main,ExifTool;
{$R *.dfm}
var
  clLite,clDark:TColor;
  ETcmd:string;

procedure TFFileDateTime.Button2Click(Sender: TObject);
var Ds,Ts: string[1];
begin
  ETcmd:='-overwrite_original'+CRLF;
  if RadioGroup4.ItemIndex=0
    then ETcmd:=ETcmd+'-Exif:DocumentName<filename'+CRLF;
  case RadioGroup1.ItemIndex of
  0: ETcmd:=ETcmd+'-filename<${Exif:DateTimeOriginal}';
  1: ETcmd:=ETcmd+'-filename<${Exif:CreateDate}';
  2: ETcmd:=ETcmd+'-filename<${Exif:ModifyDate}';
  end;
  if RadioGroup3.ItemIndex=0
    then ETcmd:=ETcmd+' %f.%e'
    else ETcmd:=ETcmd+' '+Edit1.Text+'.%e';
  ETcmd:=ETcmd+CRLF+'-d'+CRLF;
  Ds:=''; Ts:='';
  if CheckBox1.Checked then Ds:='-'; if CheckBox2.Checked then Ts:='-';
  case RadioGroup2.ItemIndex of
    0: ETcmd:=ETcmd+'%Y'+Ds+'%m'+Ds+'%d_%H'+Ts+'%M'+Ts+'%S';
    1: ETcmd:=ETcmd+'%Y'+Ds+'%m'+Ds+'%d_%H'+Ts+'%M';
    2: ETcmd:=ETcmd+'%Y'+Ds+'%m'+Ds+'%d';
  end;
  ET_OpenExec(ETcmd,FMain.GetSelectedFiles);
  FMain.UpdateLogWin;
  FMain.DeleteTmpFile;
  ModalResult:=mrOK;
end;

procedure TFFileDateTime.Button3Click(Sender: TObject);
begin
  ETcmd:='-filename<Exif:DocumentName';
  ET_OpenExec(ETcmd,FMain.GetSelectedFiles);
  FMain.UpdateLogWin;
  FMain.DeleteTmpFile;
  ModalResult:=mrOK;
end;

procedure TFFileDateTime.Button4Click(Sender: TObject);
var i,j,k,renamed: smallint;
    NewFname: string;
begin
  renamed:=0;
  with FMain.ShellList do begin
    SetCurrentDir(Path);
    j:=SelectedFiles.Count-1;
    for i:=0 to j do begin
      ETcmd:=SelectedFiles[i];
      k:=pos(' ',ETcmd);
      if k>0 then begin
        NewFname:=ETcmd; Delete(NewFname,1,k);
        if RenameFile(ETcmd,NewFname) then inc(renamed);
      end;
    end;
  end;
  ShowMessage(intToStr(renamed)+' file(s) renamed.');
  ModalResult:=mrOK;
end;

procedure TFFileDateTime.CheckBox1Click(Sender: TObject);
begin
  with RadioGroup2 do begin
    if CheckBox1.Checked then begin
      if CheckBox2.Checked then begin
        Items[0]:='YYYY-MM-DD_HH-MM-SS Filename';
        Items[1]:='YYYY-MM-DD_HH-MM Filename';
      end else begin
        Items[0]:='YYYY-MM-DD_HHMMSS Filename';
        Items[1]:='YYYY-MM-DD_HHMM Filename';
      end;
      Items[2]:='YYYY-MM-DD Filename';
    end else begin
      if CheckBox2.Checked then begin
        Items[0]:='YYYYMMDD_HH-MM-SS Filename';
        Items[1]:='YYYYMMDD_HH-MM Filename';
      end else begin
        Items[0]:='YYYYMMDD_HHMMSS Filename';
        Items[1]:='YYYYMMDD_HHMM Filename';
      end;
      Items[2]:='YYYYMMDD Filename';
    end;
  end;
end;

procedure TFFileDateTime.DisplayHint(Sender: TObject);
begin
  StatusBar1.SimpleText:=GetShortHint(Application.Hint);
end;

procedure TFFileDateTime.FormShow(Sender: TObject);
begin
  Left:=FMain.Left+FMain.GUIBorderWidth+FMain.AdvPageFilelist.Left;
  Top:=FMain.Top+FMain.GUIBorderHeight;
  clLite:=FMain.GUIclLite; clDark:=FMain.GUIclDark;
  Color:=clDark;
  with AdvPanel1 do begin
    ParentBackground:=false; Color:=clLite; ColorTo:=clDark;
  end;
  AdvPanel2.Color:=clLite; AdvPanel2.ColorTo:=clNone;
  AdvPanel3.Color:=clLite; AdvPanel3.ColorTo:=clNone;
  AdvPanel4.Color:=clLite; AdvPanel4.ColorTo:=clNone;
  RadioGroup3Click(Sender);
  Application.OnHint:=DisplayHint;
end;

procedure TFFileDateTime.RadioGroup3Click(Sender: TObject);
begin
  if RadioGroup3.ItemIndex=0 then Edit1.Color:=clLite else Edit1.Color:=clWindow;
end;

end.
