unit Geomap;

interface
uses SHDocVw;

procedure GoogleMapInit(xBrowser:TWebBrowser);
function MapGetMarkerLocation(xBrowser:TWebBrowser): string;
procedure MapGoToLocation(xLat,xLon: string);
procedure MapMarkerInvalid;
procedure MapGoToPlace(xPlace: string);
procedure MapZoom(xZoom:String);

implementation
uses Classes,MainDef,MSHTML,ActiveX,SysUtils,Variants;
var
  HTMLWin: IHTMLWindow2;
  HTMLGoogleMap: Utf8String=
'<html> '+
'<head> '+
'<meta name="viewport" content="initial-scale=1.0, user-scalable=yes" /> '+
'<style type="text/css"> '+
'  html { height: 100% } '+
'  body { height: 100%; margin: 0px; padding: 0px } '+
'  #map_canvas { height: 100% } '+
'</style> '+
'<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false&region=EU"></script> '+
'<script type="text/javascript"> '+
''+
'  var geocoder; '+
'  var map;  '+
'  var markerA; '+
//'  var infoWin; '+
''+
'  function initialize() { '+
'    geocoder = new google.maps.Geocoder();'+
//'    var latlng = new google.maps.LatLng(46.55738,15.64608); '+
'    var latlng = new google.maps.LatLng(46,15); '+
'    var myOptions = { '+
'      streetViewControl: false, '+
'      zoom: 10, '+
'      center: latlng, '+
'      mapTypeId: google.maps.MapTypeId.ROADMAP '+
'    }; '+
'    map = new google.maps.Map(document.getElementById("map_canvas"), myOptions); '+
''+ // -------------------------------------------------------------------------
//'    infoWin = new google.maps.InfoWindow({ '+
//'      maxWidth: 2 });'+
'    markerA = new google.maps.Marker({ '+
'      position: map.getCenter(), map: map,'+
'      draggable:true, icon:"http://google.com/mapfiles/ms/micons/red.png" });'+
''+
'    google.maps.event.addListener(map, "click", function(event) { '+
'      showMarker(markerA, event.latLng); });'+
''+
//'    google.maps.event.addListener(markerA, "dragstart", function() { '+
//'      infoWin.close(); });'+
''+
'    google.maps.event.addListener(markerA, "dragend", function(event) { '+
'      updateTitle(markerA, event.latLng); });'+
''+
//'    google.maps.event.addListener(markerA, "click", function() { '+
//'      showInfo(markerA); });'+
' } '+
''+ // -------------------------------------------------------------------------
'  function showMarker(xmarker, location) { '+
//'    infoWin.close(); '+
'    xmarker.setPosition(location); '+
'    xmarker.setTitle(location.toUrlValue()); }'+ //.toString =HiPrecission coords
''+
'  function updateTitle(xmarker, location) { '+
'    xmarker.setTitle(location.toUrlValue()); }'+
''+
//'  function showInfo(xmarker) { '+
//'    infoWin.setContent(xmarker.getPosition().toUrlValue());'+
//'    infoWin.open(map,xmarker); }'+
//''+
'  function GotoLocation(Lat, Lng) { '+
'   var latlng = new google.maps.LatLng(Lat,Lng);'+
//'   infoWin.close();'+
'   markerA.setIcon("http://google.com/mapfiles/ms/micons/green-dot.png");'+
'   map.setCenter(latlng);'+
'   showMarker(markerA,latlng); } '+
''+
'  function GotoPlace(address) { '+
//'    infoWin.close(); '+
'    if (geocoder) {'+
'      geocoder.geocode( { address: address}, function(results, status) { '+
'        if (status == google.maps.GeocoderStatus.OK) {'+
'          map.setCenter(results[0].geometry.location);'+
'          markerA.setIcon("http://google.com/mapfiles/ms/micons/lightblue.png");'+
'          showMarker(markerA, results[0].geometry.location);'+
'        } else {'+
'          alert("Geocode was not successful because: " + status);'+
'        }'+
'      });'+
'    }'+
'  }'+
''+
'  function SetMarkerIcon(xIco) { '+
'     markerA.setIcon(xIco); } '+
''+
''+
'  function ViewEurope() { '+
'    var latlng = new google.maps.LatLng(46.55738,15.64608); '+
//'    infoWin.close(); '+
'    map.setZoom(4); '+
'    map.setCenter(latlng); } '+
''+
'  function ZoomMarker(xZoom) { '+
'    map.setCenter(markerA.getPosition()); '+
'    map.setZoom(xZoom); } '+
''+
'  function GetLocation() { '+
'    document.getElementById("rezultat").value=markerA.getPosition().toUrlValue(); }'+
''+
'</script> '+
'</head> '+
'<body onload="initialize()"> '+
'  <input type="hidden" id="rezultat" value="" /> '+
'  <div id="map_canvas" style="width:100%; height:100%"></div> '+
'</body> '+
'</html> ';
//==============================================================================
procedure GoogleMapInit(xBrowser:TWebBrowser);
var aStream: TMemoryStream; i:integer;
begin
  i:=Pos('LatLng(46,15)',HTMLGoogleMap);
  if i>0 then begin //replace "46,15" with DefGoogleHome value
    Delete(HTMLGoogleMap,i+7,5);
    Insert(GUIsettings.DefGMapHome,HTMLGoogleMap,i+7);
  end;

  xBrowser.Navigate('about:blank');
  if Assigned(xBrowser.Document) then begin
    aStream:=TMemoryStream.Create;
    try
      aStream.WriteBuffer(Pointer(HTMLGoogleMap)^, Length(HTMLGoogleMap));
      aStream.Seek(0,soFromBeginning);
      (xBrowser.Document as IPersistStreamInit).Load(TStreamAdapter.Create(aStream));
    finally
      aStream.Free;
    end;
    HTMLWin:=(xBrowser.Document as IHTMLDocument2).parentWindow;
  end;
end;
//==============================================================================

function MapGetMarkerLocation(xBrowser:TWebBrowser): string;
  function GetElementIdValue(TagName,TagId,TagAttrib:string):string;
  var
    Document: IHTMLDocument2;
    Body: IHTMLElement2;
    Tags: IHTMLElementCollection;
    Tag: IHTMLElement;
    i: integer;
  begin
    result:='';
    if not Supports(xBrowser.Document, IHTMLDocument2, Document) then
      raise Exception.Create('Invalid HTML document');
    if not Supports(Document.body, IHTMLElement2, Body) then
      raise Exception.Create('Can''t find <body> element');
    Tags:=Body.getElementsByTagName(UpperCase(TagName));
    for i:=0 to Pred(Tags.length) do begin
      Tag:=Tags.item(i,EmptyParam) as IHTMLElement;
      if Tag.id=TagId then result:=Tag.getAttribute(TagAttrib,0);
    end;
  end;
begin
  HTMLWin.execScript('GetLocation()', 'JavaScript');
  result:=GetElementIdValue('input', 'rezultat', 'value')
end;

procedure MapGoToLocation(xLat,xLon: string);
begin
  HTMLWin.execScript(Format('GotoLocation(%s,%s)',[xLat, xLon]), 'JavaScript');
  HTMLWin.focus;
end;

procedure MapMarkerInvalid;
begin
  HTMLWin.execScript('SetMarkerIcon("http://google.com/mapfiles/ms/micons/red.png")', 'JavaScript');
  HTMLWin.focus;
end;

procedure MapGoToPlace(xPlace: string);
begin
  HTMLWin.execScript(Format('GotoPlace(%s)',[QuotedStr(xPlace)]), 'JavaScript');
  HTMLWin.focus;
end;

procedure MapZoom(xZoom:String);
begin
  HTMLWin.execScript(Format('ZoomMarker(%s)',[xZoom]), 'JavaScript');
  HTMLWin.focus;
end;

end.
