unit MainDef;

interface
uses Classes; //ShlObj;

type
  GUIsettingsRec=record
    Language: string[7];
    AutoRotatePreview: boolean;
    DefStartupUse: boolean;
    DefStartupDir: AnsiString;
    DefExportUse: boolean;
    DefExportDir: AnsiString;
    ThumbSize: smallint;
    UseExitDetails: boolean;
    AutoIncLine: boolean;
    //StartupThumbs: boolean;
    EnableGMap: boolean;
    DefGMapHome: string[23];
    GUIcolor: smallint;
    ETdirDefCmd: smallint;
  end;
  FListColDefRec=record
    Caption:string;
    Width: smallint;
    AlignR: smallint;
  end;
  FListColUsrRec=record
    Caption:string;
    Command:string;
    Width: smallint;
    AlignR: smallint;
  end;
  QuickTagRec=record
    Caption:string;
    Command:string;
    Help: string;
    NoEdit: boolean;
  end;

var
  FListStdColWidth: array[0..3] of smallint=(200,88,80,120); //[Filename][Size][Type][Date modified]
  FListColDef1: array[0..7] of FListColDefRec=
  ((Caption:'ExpTime'; Width:64; AlignR:6),
   (Caption:'FNumber'; Width:64; AlignR:4),
   (Caption:'ISO'; Width:48; AlignR:5),
   (Caption:'ExpComp.'; Width:72; AlignR:4),
   (Caption:'FLength'; Width:72; AlignR:8),
   (Caption:'Flash'; Width:56; AlignR:0),
   (Caption:'ExpProgram'; Width:88; AlignR:0),
   (Caption:'Orientation'; Width:80; AlignR:0));
  FListColDef2: array[0..5] of FListColDefRec=
  ((Caption:'DateTime'; Width:120; AlignR:0),
   (Caption:'GPS'; Width:48; AlignR:0),
   (Caption:'Country'; Width:80; AlignR:0),
   (Caption:'Province'; Width:80; AlignR:0),
   (Caption:'City'; Width:120; AlignR:0),
   (Caption:'Location'; Width:120; AlignR:0));
  FListColDef3: array[0..4] of FListColDefRec=
  ((Caption:'Artist'; Width:120; AlignR:0),
   (Caption:'Rating'; Width:48; AlignR:0),
   (Caption:'Type'; Width:120; AlignR:0),
   (Caption:'Event'; Width:120; AlignR:0),
   (Caption:'PersonInImage'; Width:120; AlignR:0));
  FListColUsr: array of FListColUsrRec;

  GUIsettings: GUIsettingsRec;
  ETdirectCmd: TStringList;
  QuickTags: array of QuickTagRec;
  MarkedTags: string;
  CustomViewTags: string;
  GpsXmpDir:string='';
  WrkIniDir:string='';

procedure ReadGUIini;
function SaveGUIini:boolean;
function LoadWorkspaceIni(IniFName: string):boolean;
function SaveWorkspaceIni(IniFName: string): boolean;
function BrowseFolderDlg(const Title: string; iFlag:integer; const StartFolder: string=''): string;
procedure ChartFindFiles(StartDir,FileMask: string; subDir:boolean);
function GetNrOfFiles(StartDir,FileMask: string; subDir:boolean):integer;

implementation
uses Main,IniFiles,LogWin,SysUtils,Forms,StrUtils,Dialogs,ExifTool,Windows,ExifInfo,ShellAPI,ShlObj;

const
  CRLF=#13#10;
  Ini_ETGUI='ExifToolGUI';
  Ini_Settings='GUIsettings';
  Ini_Options='EToptions';

var
  GUIini: TIniFile;
  TmpItems: TStrings;
  lg_StartFolder: string;

procedure ReadGUIini;
var i,n,x: smallint;
    tx: string;

  procedure SetQuickTag(var x:smallint; const Name:string; Cmd: string);
  begin
    with QuickTags[x] do begin
      Caption:=Name;
      n:=pos('^',Cmd);
      if n=0 then begin
        Command:=Cmd; SetLength(Help,0);
      end else begin
        Command:=LeftStr(Cmd,n-1); Delete(Cmd,1,n); Help:=Cmd;
      end;
    end;
    inc(x);
  end;

begin
  TmpItems:=TStringList.Create;
  ETdirectCmd:=TStringList.Create;
  GUIini:=TIniFile.Create(ChangeFileExt(Application.ExeName,'v5.ini'));
  with GUIini,FMain do begin
    n:=0; if WindowState=wsMaximized then inc(n); //check shortcut setting
    if ReadBool(Ini_ETGUI,'StartMax',false) then inc(n);
    Top:=ReadInteger(Ini_ETGUI,'WinTop',40);
    Left:=ReadInteger(Ini_ETGUI,'WinLeft',60);
    Width:=ReadInteger(Ini_ETGUI,'WinWidth',1024);
    Height:=ReadInteger(Ini_ETGUI,'WinHeight',660);
    if n>0 then WindowState:=wsMaximized;
    AdvPanelBrowse.Width:=ReadInteger(Ini_ETGUI,'BrowseWidth',240);
    AdvPagePreview.Height:=ReadInteger(Ini_ETGUI,'PreviewHeight',220);
    AdvPageMetadata.Width:=ReadInteger(Ini_ETGUI,'MetadataWidth',322);
    MetadataList.ColWidths[0]:=ReadInteger(Ini_ETGUI,'MetadataTagWidth',144);
    StatusBar.Panels[0].Width:=AdvPanelBrowse.Width+5;

    ShellTree.SelectedFolder:=ReadString(Ini_ETGUI,'DefaultDir','c:\');
    with FLogWin do begin
      Top:=ReadInteger(Ini_ETGUI,'LogWinTop',106);
      Left:=ReadInteger(Ini_ETGUI,'LogWinLeft',108);
      Width:=ReadInteger(Ini_ETGUI,'LogWinWidth',580);
      Height:=ReadInteger(Ini_ETGUI,'LogWinHeight',200);
    end;
    ShellList.Column[0].Width:=ReadInteger(Ini_ETGUI,'FNameWidth',200);

    with GUIsettings do begin
      Language:=ReadString(Ini_Settings,'Language','');
      ET_Options.ETLangDef:=Language+CRLF;; if Language='' then ET_Options.ETLangDef:='';
      AutoRotatePreview:=ReadBool(Ini_Settings,'AutoRotatePreview',false);
      tx:=ReadString(Ini_Settings,'FileFilters','*.JPG|*.CR2|*.JPG;*.CR2');
      repeat
        i:=Pos('|',tx);
        if i>0 then begin
          CBoxFileFilter.Items.Append(LeftStr(tx,i-1));
          Delete(tx,1,i);
        end else CBoxFileFilter.Items.Append(tx);
      until i=0;
      DefStartupUse:=ReadBool(Ini_Settings,'DefStartupUse',false);
      DefStartupDir:=ReadString(Ini_Settings,'DefStartupDir','c:\');
      if DefStartupUse then ShellTree.SelectedFolder:=DefStartupDir;
      DefExportUse:=ReadBool(Ini_Settings,'DefExportUse',false);
      DefExportDir:=ReadString(Ini_Settings,'DefExportDir','');
      ThumbSize:=ReadInteger(Ini_Settings,'ThumbsSize',0);
      case ThumbSize of
        0: i:=96; 1: i:=128; 2: i:=160; else i:=96;
      end;
      with FMain.ShellList do begin
        ThumbnailWidth:=i; ThumbnailHeight:=i;
      end;

      EnableGMap:=ReadBool(Ini_Settings,'EnableGMap',false);
      DefGMapHome:=ReadString(Ini_Settings,'DefGMapHome','46.55738,15.64608');
      if (pos('.',DefGMapHome)=0) or (pos(',',DefGMapHome)=0)
        then DefGMapHome:='46.55738,15.64608';
      GUIcolor:=ReadInteger(Ini_Settings,'GUIcolor',0);
      UseExitDetails:=ReadBool(Ini_Settings,'UseExitDetails',false);
      if UseExitDetails then begin
        FMain.CBoxDetails.ItemIndex:=ReadInteger(Ini_Settings,'DetailsSel',0);
        FMain.SpeedBtnDetails.Down:=ReadBool(Ini_Settings,'DetailsDown',true);
      end;
      AutoIncLine:=ReadBool(Ini_Settings,'AutoIncLine',true);
      ETdirDefCmd:=ReadInteger(Ini_Settings,'ETdirDefCmd',-1);
    end;

    with ET_Options do begin
      MDontBackup.Checked:=ReadBool(Ini_Options,'DontBackup',true);
      if not MDontBackup.Checked then ETBackupMode:='';
      MPreserveDateMod.Checked:=ReadBool(Ini_Options,'PreserveDateMod',false);
      if MPreserveDateMod.Checked then ETFileDate:='-P'+CRLF;
      ETSeparator:='-sep'+CRLF+ReadString(Ini_Options,'KeySeparator','*')+CRLF;
      MIgnoreErrors.Checked:=ReadBool(Ini_Options,'IgnoreErrors',false);
      if MIgnoreErrors.Checked then ETMinorError:='-m'+CRLF;
      MShowGPSdecimal.Checked:=ReadBool(Ini_Options,'GPSinDecimal',true);
      if MShowGPSdecimal.Checked then ETGPSformat:='-c'+CRLF+'%.6f'+CRLF
                                 else ETGPSformat:='-c'+CRLF+'%d%.4f'+CRLF;
      MShowSorted.Checked:=ReadBool(Ini_Options,'ShowSorted',false);
      MShowComposite.Checked:=ReadBool(Ini_Options,'ShowComposite',false);
      MNotDuplicated.Checked:=ReadBool(Ini_Options,'NotDuplicated',false);
    end;

    //Custom FList columns
    ReadSectionValues('FListUserDefColumn',TmpItems);
    i:=TmpItems.Count;
    if i>0 then begin
      SetLength(FListColUsr,i);
      for n:=0 to i-1 do with FListColUsr[n] do begin
        tx:=TmpItems[n]; x:=pos('=',tx);
        Caption:=LeftStr(tx,x-1);
        Delete(tx,1,x); x:=pos(' ',tx);
        if x=0 then begin
          Command:=tx; Width:=80;
        end else begin
          Command:=LeftStr(tx,x-1); Delete(tx,1,x);
          Width:=StrToIntDef(tx,80);
        end;
        AlignR:=0;
      end;
    end else begin
      SetLength(FListColUsr,3);
      with FListColUsr[0] do begin
        Caption:='DateTime'; Command:='-exif:DateTimeOriginal';
        Width:=120; AlignR:=0;
      end;
       with FListColUsr[1] do begin
        Caption:='Rating'; Command:='-xmp-xmp:Rating';
        Width:=60; AlignR:=0;
      end;
      with FListColUsr[2] do begin
        Caption:='Photo title'; Command:='-xmp-dc:Title';
        Width:=160; AlignR:=0;
      end;
    end;
    //--- ETdirect commands---
    ETdirectCmd.Clear; ReadSection('ETdirectCmd',CBoxETdirect.Items);
    n:=CBoxETdirect.Items.Count;
    if n=0 then with CBoxETdirect.Items do begin
      Append('Set Exif:Copyright to [Year by MyName]');
      ETdirectCmd.Append('-d %Y "-Exif:Copyright<$DateTimeOriginal by MyName"');
      n:=2;
    end else begin
      for i:=0 to n-1 do ETdirectCmd.Append(ReadString('ETdirectCmd',CBoxETdirect.Items[i],'?'));
    end;
    i:=GUIsettings.ETdirDefCmd;
    if i<n then begin
      CBoxETdirect.ItemIndex:=i;
      if i<>-1 then begin
        EditETdirect.Text:=ETdirectCmd[i]; SpeedBtnETdirectDel.Enabled:=true;
      end;
    end else GUIsettings.ETdirDefCmd:=-1;
    //---------------------
    ReadSectionValues('WorkspaceTags',TmpItems);
    i:=TmpItems.Count;
    if i>0 then begin
      SetLength(QuickTags,i);
      for n:=0 to i-1 do with QuickTags[n] do begin
        tx:=TmpItems[n];
        x:=pos('=',tx); Caption:=LeftStr(tx,x-1); Delete(tx,1,x);
        x:=pos('^',tx);
        if x=0 then begin
          Command:=tx; SetLength(Help,0);
        end else begin
          Command:=LeftStr(tx,x-1); Delete(tx,1,x); Help:=tx;
        end;
      end;
    end else begin
      SetLength(QuickTags,25); i:=0;
      SetQuickTag(i,'EXIF','-GUI-SEP');
      SetQuickTag(i,'Make','-exif:Make');
      SetQuickTag(i,'Model','-exif:Model');
      SetQuickTag(i,'LensModel','-exif:LensModel');
      SetQuickTag(i,'ExposureTime','-exif:ExposureTime^[1/50] or [0.02]');
      SetQuickTag(i,'FNumber','-exif:FNumber');
      SetQuickTag(i,'ISO','-exif:ISO');
      SetQuickTag(i,'FocalLength','-exif:FocalLength^[28] -mm not necessary');
      SetQuickTag(i,'Flash#','-exif:Flash^[ 0 ]=No flash, [ 1 ]=Flash fired');
      SetQuickTag(i,'Orientation#','-exif:Orientation^[ 1 ]=0, [ 3 ]=180, [ 6 ]=+90, [ 8 ]=-90');
      SetQuickTag(i,'DateTimeOriginal','-exif:DateTimeOriginal^[2012:01:14 20:00:00]');
      SetQuickTag(i,'CreateDate','-exif:CreateDate^[2012:01:14 20:00:00]');
      SetQuickTag(i,'Artist*','-exif:Artist^Bogdan Hrastnik');
      SetQuickTag(i,'Copyright','-exif:Copyright^Use Alt+0169 to get  character');
      SetQuickTag(i,'Software','-exif:Software');
      SetQuickTag(i,'Geotagged?','-Gps:GPSLatitude');

      SetQuickTag(i,'About photo','-GUI-SEP');
      //SetQuickTag(i,'Creator','-xmp-dc:Creator');
      SetQuickTag(i,'Type','-xmp-dc:Type^[Landscape] or [Studio+Portrait] ..');
      //SetQuickTag(i,'Rating','-xmp-xmp:Rating^Integer value [ 0 ] .. [ 5 ]');
      //SetQuickTag(i,'Title','-xmp-dc:Title');
      SetQuicktag(i,'Event','-xmp-iptcExt:Event^[Vacations] or [Trip] ..');
      SetQuickTag(i,'PersonInImage','-xmp:PersonInImage^[Phil] or [Harry+Sally] or [-Peter] ..');
      SetQuickTag(i,'Keywords','-xmp-dc:Subject^[tree] or [flower+rose] or [-fish] or [+bird-fish] ..');
      SetQuickTag(i,'Country','-xmp:LocationShownCountryName');
      SetQuickTag(i,'Province','-xmp:LocationShownProvinceState');
      SetQuickTag(i,'City','-xmp:LocationShownCity');
      SetQuickTag(i,'Location','-xmp:LocationShownSublocation');

    end;
    for i:=0 to length(QuickTags)-1 do begin
      tx:=QuickTags[i].Caption;
      QuickTags[i].NoEdit:=(RightStr(tx,1)='?');
      tx:=UpperCase(LeftStr(QuickTags[i].Command,4));
      QuickTags[i].NoEdit:=QuickTags[i].NoEdit or (tx='-GUI');
    end;
    //--------------------
    MarkedTags:=ReadString('TagList','MarkedTags','Artist ');
    n:=Length(MarkedTags);
    if MarkedTags[n]='<' then MarkedTags[n]:=' ' else MarkedTags:='Artist ';
    //--------------------
    CustomViewTags:=ReadString('TagList','CustomView','-Exif:Artist ');
    n:=Length(CustomViewTags);
    if CustomViewTags[n]='<' then CustomViewTags[n]:=' ' else CustomViewTags:='-Exif:Artist ';

  end;
  GUIini.Free;
  TmpItems.Free;
end;

function SaveGUIini:boolean;
var i,n: smallint; Tx: string;
begin
  //DeleteFile(ChangeFileExt(Application.ExeName,'.ini'));
  // ^- EraseSection used instead
  GUIini:=TIniFile.Create(ChangeFileExt(Application.ExeName,'v5.ini'));
  try
    with GUIini,FMain do begin
      EraseSection(Ini_ETGUI);
      if WindowState<>wsMaximized then begin
        WriteBool(Ini_ETGUI,'StartMax',false);
        WriteInteger(Ini_ETGUI,'WinTop',Top);
        WriteInteger(Ini_ETGUI,'WinLeft',Left);
        WriteInteger(Ini_ETGUI,'WinWidth',Width);
        WriteInteger(Ini_ETGUI,'WinHeight',Height);
      end else WriteBool(Ini_ETGUI,'StartMax',true);
      WriteInteger(Ini_ETGUI,'BrowseWidth',AdvPanelBrowse.Width);
      WriteInteger(Ini_ETGUI,'PreviewHeight',AdvPagePreview.Height);
      WriteInteger(Ini_ETGUI,'MetadataWidth',AdvPageMetadata.Width);
      WriteInteger(Ini_ETGUI,'MetadataTagWidth',MetadataList.ColWidths[0]);
      WriteString(Ini_ETGUI,'DefaultDir',ShellTree.SelectedFolder);
      with FLogWin do begin
        WriteInteger(Ini_ETGUI,'LogWinTop',Top);
        WriteInteger(Ini_ETGUI,'LogWinLeft',Left);
        WriteInteger(Ini_ETGUI,'LogWinWidth',Width);
        WriteInteger(Ini_ETGUI,'LogWinHeight',Height);
      end;
      WriteInteger(Ini_ETGUI,'FNameWidth',ShellList.Column[0].Width);

      EraseSection(Ini_Settings);
      with GUIsettings do begin
        WriteString(Ini_Settings,'Language',Language);
        WriteBool(Ini_Settings,'AutoRotatePreview',AutoRotatePreview);
        i:=CBoxFileFilter.Items.Count-1; Tx:='';
        if i>0 then for n:=1 to i do begin
          Tx:=Tx+CBoxFileFilter.Items[n]; if n<i then Tx:=Tx+'|';
        end;
        WriteString(Ini_Settings,'FileFilters',Tx);
        WriteBool(Ini_Settings,'DefStartupUse',DefStartupUse);
        WriteString(Ini_Settings,'DefStartupDir',DefStartupDir);
        WriteBool(Ini_Settings,'DefExportUse',DefExportUse);
        WriteString(Ini_Settings,'DefExportDir',DefExportDir);
        WriteInteger(Ini_Settings,'ThumbsSize',ThumbSize);

        WriteBool(Ini_Settings,'EnableGMap',EnableGMap);
        WriteString(Ini_Settings,'DefGMapHome',DefGMapHome);
        WriteInteger(Ini_Settings,'GUIcolor',GUIcolor);

        WriteBool(Ini_Settings,'UseExitDetails',UseExitDetails);
        WriteInteger(Ini_Settings,'DetailsSel',FMain.CBoxDetails.ItemIndex);
        WriteBool(Ini_Settings,'DetailsDown',FMain.SpeedBtnDetails.Down);
        WriteBool(Ini_Settings,'AutoIncLine',AutoIncLine);
        WriteInteger(Ini_Settings,'ETdirDefCmd',ETdirDefCmd);
      end;

      EraseSection(Ini_Options);
      WriteBool(Ini_Options,'DontBackup',MDontBackup.Checked);
      WriteBool(Ini_Options,'PreserveDateMod',MPreserveDateMod.Checked);
      Tx:=ET_Options.ETSeparator; Delete(Tx,1,6); SetLength(Tx,1);
      WriteString(Ini_Options,'KeySeparator',Tx);
      WriteBool(Ini_Options,'IgnoreErrors',MIgnoreErrors.Checked);
      WriteBool(Ini_Options,'GPSinDecimal',MShowGPSdecimal.Checked);
      WriteBool(Ini_Options,'ShowSorted',MShowSorted.Checked);
      WriteBool(Ini_Options,'ShowComposite',MShowComposite.Checked);
      WriteBool(Ini_Options,'NotDuplicated',MNotDuplicated.Checked);

      EraseSection('FListUserDefColumn');
      i:=Length(FListColUsr)-1;
      for n:=0 to i do begin
        Tx:=FListColUsr[n].Command+' '+IntToStr(FListColUsr[n].Width);
        WriteString('FListUserDefColumn',FListColUsr[n].Caption,Tx);
      end;

      EraseSection('ETdirectCmd');
      for n:=0 to ETdirectCmd.Count-1 do
        WriteString('ETdirectCmd',CBoxETdirect.Items[n],ETdirectCmd[n]);

      EraseSection('WorkspaceTags');
      for n:=0 to Length(QuickTags)-1 do with QuickTags[n] do begin
        tx:=Command;
        if Length(Help)>0 then tx:=tx+'^'+Help;
        WriteString('WorkspaceTags',Caption,tx);
      end;

      EraseSection('TagList');
      n:=Length(MarkedTags); MarkedTags[n]:='<';
      WriteString('TagList','MarkedTags',MarkedTags);
      n:=Length(CustomViewTags); CustomViewTags[n]:='<';
      WriteString('TagList','CustomView',CustomViewTags);

    end;
    GUIini.Free; ETdirectCmd.Free;
    result:=true;
  except else
    GUIini.Free; ETdirectCmd.Free;
    result:=false;
  end;
end;

function LoadWorkspaceIni(IniFName: string):boolean;
var i,n,x:smallint;
  tx:string;
begin
  result:=false;
  //tx:=ExtractFilePath(Application.ExeName)+'WorkspaceTags.ini';
  if FileExists(IniFName) then begin
    TmpItems:=TStringList.Create;
    GUIini:=TIniFile.Create(IniFName);
    with GUIini do begin
      ReadSectionValues('WorkspaceTags',TmpItems);
      i:=TmpItems.Count;
      if i>0 then begin
        SetLength(QuickTags,i);
        for n:=0 to i-1 do with QuickTags[n] do begin
          tx:=TmpItems[n];
          x:=pos('=',tx); Caption:=LeftStr(tx,x-1); Delete(tx,1,x);
          x:=pos('^',tx);
          if x=0 then begin
            Command:=tx; SetLength(Help,0);
          end else begin
            Command:=LeftStr(tx,x-1); Delete(tx,1,x); Help:=tx;
          end;
        end;
        for i:=0 to length(QuickTags)-1 do begin
          tx:=QuickTags[i].Caption;
          QuickTags[i].NoEdit:=(RightStr(tx,1)='?');
          tx:=UpperCase(LeftStr(QuickTags[i].Command,4));
          QuickTags[i].NoEdit:=QuickTags[i].NoEdit or (tx='-GUI');
        end;
        result:=true;
      end;
    end;
    GUIini.Free;
    TmpItems.Free;
  end;
end;

function SaveWorkspaceIni(IniFName: string): boolean;
var n: smallint; tx: string; F: TextFile;
begin
  try
    AssignFile(F,IniFName); Rewrite(F); Close(F);
    GUIini:=TIniFile.Create(IniFName);
    with GUIini do begin
      for n:=0 to Length(QuickTags)-1 do with QuickTags[n] do begin
        tx:=Command;
        if Length(Help)>0 then tx:=tx+'^'+Help;
        WriteString('WorkspaceTags',Caption,tx);
      end;
    end;
    GUIini.Free; result:=true;
  except else
    GUIini.Free; result:=false;
  end;
end;

//------------------------------------------------------------------------------
function BrowseFolderCallBack(Wnd: HWND; uMsg: UINT; lParam,
lpData: LPARAM): Integer stdcall;
begin
  if uMsg = BFFM_INITIALIZED then
    SendMessage(Wnd,BFFM_SETSELECTION, 1, Integer(@lg_StartFolder[1]));
  result := 0;
end;

function BrowseFolderDlg(const Title: string; iFlag:integer; const StartFolder: string=''): string;
//iFlag: 0=BIF_RETURNONLYFSDIRS, 1=BIF_BROWSEINCLUDEFILES (=+Network)
//doesn't matter if StartFolder has final dash or not
var
  lpItemID : PItemIDList;
  BrowseInfo : TBrowseInfo;
  DisplayName : array[0..MAX_PATH] of char;
begin
  Result:='';
  FillChar(BrowseInfo, sizeof(TBrowseInfo), #0);
  lg_StartFolder:=StartFolder;
  with BrowseInfo do begin
    hwndOwner := Application.Handle;
    pszDisplayName := @DisplayName;
    lpszTitle := PChar(Title);
    ulFlags := iFlag;
    if StartFolder<>'' then BrowseInfo.lpfn:=BrowseFolderCallBack;
  end;
  lpItemID := SHBrowseForFolder(BrowseInfo);
  //-we got folder name (without path) into DisplayName
  if lpItemId <> nil then begin //get full path
    SHGetPathFromIDList(lpItemID, DisplayName);
    Result := DisplayName; //=without final dash
    GlobalFreePtr(lpItemID);
  end;
end;
//------------------------------------------------------------------------------

procedure ChartFindFiles(StartDir,FileMask: string; subDir:boolean);
var
  SR: TSearchRec;
  DirList: TStringList;
  IsFound,doSub: Boolean;
  i: integer;
  w: word;
begin
  if StartDir[length(StartDir)]<>'\' then StartDir:=StartDir+'\';
  doSub:=subDir;
  // Build a list of the files in directory StartDir -not the directories!
  IsFound:=FindFirst(StartDir+FileMask, faAnyFile-faDirectory, SR)=0;
  while IsFound do begin
    GetMetadata(StartDir+SR.Name,false,false,false,false);
    with Foto do begin
      //focal length:
      w:=pos('.',ExifIFD.FocalLength); if w>0 then Delete(ExifIFD.FocalLength,w,1); //5.8->58
      w:=StrToIntDef(ExifIFD.FocalLength,0);
      if w>0 then begin
        if (w>=Low(ChartFLength)) and (w<=High(ChartFLength)) then inc(ChartFLength[w]);
      end;
      //aperture:
      w:=pos('.',ExifIFD.FNumber); if w>0 then Delete(ExifIFD.FNumber,w,1); //4.0->40
      w:=StrToIntDef(ExifIFD.FNumber,0);
      if w>0 then begin
        if (w>=Low(ChartFNumber)) and (w<=High(ChartFNumber)) then inc(ChartFNumber[w]);
      end;
      //ISO:
      w:=StrToIntDef(ExifIFD.ISO,0) div 10; // 800->80
      if w>0 then begin
        if (w>=Low(ChartISO)) and (w<=High(ChartISO)) then inc(ChartISO[w]);
      end;
    end;
    IsFound:=FindNext(SR)=0;
  end;

  SysUtils.FindClose(SR);
  // Build a list of subdirectories
  if doSub then begin
    DirList:=TStringList.Create;
    IsFound:=FindFirst(StartDir+'*.*',faAnyFile,SR)=0;
    while IsFound do begin
      if ((SR.Attr and faDirectory)<>0) and (SR.Name[1]<>'.') then DirList.Add(StartDir+SR.Name);
      IsFound:=FindNext(SR)=0;
    end;
    SysUtils.FindClose(SR);
    // Scan the list of subdirectories
    for i:=0 to DirList.Count-1 do ChartFindFiles(DirList[i], FileMask, doSub);
    DirList.Free;
  end;
end;

function GetNrOfFiles(StartDir,FileMask: string; subDir:boolean):integer;
var
  SR: TSearchRec;
  DirList: TStringList;
  IsFound,doSub: Boolean;
  i,x: integer;
begin
  if StartDir[length(StartDir)]<>'\' then StartDir:=StartDir+'\';
  doSub:=subDir; x:=0;
  // Count files in directory
  IsFound:=FindFirst(StartDir+FileMask, faAnyFile-faDirectory, SR)=0;
  while IsFound do begin
    inc(x);
    IsFound:=FindNext(SR)=0;
  end;
  SysUtils.FindClose(SR);

  // Build a list of subdirectories
  if doSub then begin
    DirList:=TStringList.Create;
    IsFound:=FindFirst(StartDir+'*.*',faAnyFile,SR)=0;
    while IsFound do begin
      if ((SR.Attr and faDirectory)<>0) and (SR.Name[1]<>'.') then DirList.Add(StartDir+SR.Name);
      IsFound:=FindNext(SR)=0;
    end;
    SysUtils.FindClose(SR);
    // Scan the list of subdirectories
    for i:=0 to DirList.Count-1 do x:=x+GetNrOfFiles(DirList[i], FileMask, doSub);
    DirList.Free;
  end;
  result:=x;
end;


end.
